package bank.infrastructure;

import bank.model.Customer;


public interface StatefulService {
	/**
	 * registers new objects with this service or notifies this
	 * service that an object has been modified
	 */
	void insertOrUpdate(Object object);

	/**
	 * same as insertOrUpdate(Object object); plus this method 
	 * calls insertOrUpdate on child objects
	 */
	void insertOrUpdateRecursive(Customer customer);

	/**
	 * executes rules 
	 */
	void executeRules();
  
	/**
	 * releases all resources held by this service
	 */
	void terminate();
  
}
